//:://////////////////////////////////////////////
//::        Function - GetMaxAllowedLevel
//:://////////////////////////////////////////////
/*
                Function Description

Use this function to set the maximum level at which
ANY member of the party can be to generate treasure.
If ANY member of the party is higher than this, all
they will get is worn out boots.

For example, if the level cap on an area is 5, and
ANY member of a party consisting of 4,3,4,6 opens a
chest in the area, they will get boots.

Each are should have an entry in this table matching its tag.
If a match is not found the function will return 100 - but
this is not a good thing because that means anyone can
generate treasure in the area - so be careful!

IMPORTANT NOTE: You can override the area wide level
restrictions by adding an item specific statement.
This can be useful if you have a tough boss in an
otherwise weaker area. If you do assign an override,
insert the item tag into the second part of the function.

*/

int GetMaxAllowedLevel (object oCaller)
{
    int iMaxAllowedLevel = 100;
    string sTag = GetTag (oCaller);
    string sAreaTag = GetTag(GetArea(oCaller));

    // Get The Area's Default Max Level
    if (sAreaTag == "TamaraCoast") iMaxAllowedLevel = 100;
    if (sAreaTag == "Bugbear1") iMaxAllowedLevel = 100;

    // Set the Max Level by the object's tag instead
    if (sTag == "AIRELEMENTAL") iMaxAllowedLevel = 100;
    if (sTag == "ANCIENTBLACKDRAGON") iMaxAllowedLevel = 100;
    if (sTag == "ANCIENTBRONZEDRAGON") iMaxAllowedLevel = 100;
    if (sTag == "ANCIENTCOPPERDRAGON") iMaxAllowedLevel = 100;
    if (sTag == "ANCIENTGREENDRAGON") iMaxAllowedLevel = 100;
    if (sTag == "ANCIENTREDDRAGON") iMaxAllowedLevel = 100;
    if (sTag == "ANCIENTSILVERDRAGON") iMaxAllowedLevel = 100;
    if (sTag == "ANCIENTWHITEDRAGON") iMaxAllowedLevel = 100;
    if (sTag == "ANIMALMASTER") iMaxAllowedLevel = 100;
    if (sTag == "ARENACHAMPION") iMaxAllowedLevel = 100;
    if (sTag == "BABYREDDRAGON") iMaxAllowedLevel = 100;
    if (sTag == "BANDITCHIEF") iMaxAllowedLevel = 100;
    if (sTag == "BALKER") iMaxAllowedLevel = 100;
    if (sTag == "BALORLORD") iMaxAllowedLevel = 100;
    if (sTag == "BANDIT") iMaxAllowedLevel = 15;
    if (sTag == "BANDITARCHER") iMaxAllowedLevel = 15;
    if (sTag == "BANDITMAGE") iMaxAllowedLevel = 15;
    if (sTag == "BANDITROGUE") iMaxAllowedLevel = 15;
    if (sTag == "BARROCK") iMaxAllowedLevel = 100;
    if (sTag == "BIKINIMONK") iMaxAllowedLevel = 100;
    if (sTag == "BLACKDRAGONGAURDIAN") iMaxAllowedLevel = 100;
    if (sTag == "BLUEDWARF") iMaxAllowedLevel = 100;
    if (sTag == "BRIGGS") iMaxAllowedLevel = 100;
    if (sTag == "BUDOC") iMaxAllowedLevel = 100;
    if (sTag == "CAINWARRIOR") iMaxAllowedLevel = 100;
    if (sTag == "COPPERDRAGONGAURDIAN") iMaxAllowedLevel = 100;
    if (sTag == "CULTDICIPLE") iMaxAllowedLevel = 100;
    if (sTag == "CULTDICIPLESCOUT") iMaxAllowedLevel = 100;
    if (sTag == "CULTLEADER") iMaxAllowedLevel = 100;
    if (sTag == "CULTOFMINIMAGE") iMaxAllowedLevel = 100;
    if (sTag == "CULTOFMINIWARRIOR") iMaxAllowedLevel = 100;
    if (sTag == "CULTWARRIOR") iMaxAllowedLevel = 100;
    if (sTag == "DRAKALM") iMaxAllowedLevel = 100;
    if (sTag == "DUERGERMAGE") iMaxAllowedLevel = 100;
    if (sTag == "DUERGERROGUE") iMaxAllowedLevel = 100;
    if (sTag == "DUNEPRIEST") iMaxAllowedLevel = 100;
    if (sTag == "DWARFBLADESLINGER") iMaxAllowedLevel = 100;
    if (sTag == "DWARFHIGHWIZARD") iMaxAllowedLevel = 100;
    if (sTag == "DWARFPRIEST") iMaxAllowedLevel = 100;
    if (sTag == "EARTHELEMENTAL") iMaxAllowedLevel = 100;
    if (sTag == "ELRIETHEMIGHTY") iMaxAllowedLevel = 100;
    if (sTag == "EVILFAIRY") iMaxAllowedLevel = 100;
    if (sTag == "FIREDRAGON") iMaxAllowedLevel = 100;
    if (sTag == "FIREELEMENTAL") iMaxAllowedLevel = 100;
    if (sTag == "GHOULLORD") iMaxAllowedLevel = 100;
    if (sTag == "GIANTKEYKEEPER") iMaxAllowedLevel = 100;
    if (sTag == "GIANTMAGE") iMaxAllowedLevel = 100;
    if (sTag == "GLEBUR") iMaxAllowedLevel = 100;
    if (sTag == "GREENDRAGONGAURDIAN") iMaxAllowedLevel = 100;
    if (sTag == "GREENDWARF") iMaxAllowedLevel = 100;
    if (sTag == "HALFBEASTRANGER") iMaxAllowedLevel = 100;
    if (sTag == "HLAFBEASTWARRIOR") iMaxAllowedLevel = 100;
    if (sTag == "HEARTLESS") iMaxAllowedLevel = 100;
    if (sTag == "HOLOGAURD") iMaxAllowedLevel = 100;
    if (sTag == "HOLO") iMaxAllowedLevel = 100;
    if (sTag == "KEEPEROFKEYSEAST") iMaxAllowedLevel = 100;
    if (sTag == "KINGDUERGER") iMaxAllowedLevel = 100;
    if (sTag == "LIGHTINGDRAGON") iMaxAllowedLevel = 100;
    if (sTag == "LIZARDCHIEF") iMaxAllowedLevel = 100;
    if (sTag == "LORDSHACKNUK") iMaxAllowedLevel = 100;
    if (sTag == "MALCOM") iMaxAllowedLevel = 100;
    if (sTag == "MALCOMPROTECTOR") iMaxAllowedLevel = 100;
    if (sTag == "MERCENARY") iMaxAllowedLevel = 100;
    if (sTag == "METALMONK") iMaxAllowedLevel = 100;
    if (sTag == "MINGTAO") iMaxAllowedLevel = 100;
    if (sTag == "MINIMONK") iMaxAllowedLevel = 100;
    if (sTag == "MONKOSAURUS") iMaxAllowedLevel = 100;
    if (sTag == "MONXIE") iMaxAllowedLevel = 100;
    if (sTag == "MRROBATO") iMaxAllowedLevel = 100;
    if (sTag == "MUMMYWARRIOR") iMaxAllowedLevel = 100;
    if (sTag == "NAMELESSCULTPRIEST") iMaxAllowedLevel = 100;
    if (sTag == "NORTHKEEPEROFKEYS") iMaxAllowedLevel = 100;
    if (sTag == "ORC_ARCHER") iMaxAllowedLevel = 100;
    if (sTag == "ORC_CHAMP") iMaxAllowedLevel = 100;
    if (sTag == "ORC_Chief") iMaxAllowedLevel = 100;
    if (sTag == "ORC_Boss") iMaxAllowedLevel = 100;
    if (sTag == "QUEENDUERGER") iMaxAllowedLevel = 100;
    if (sTag == "RAINMAKER") iMaxAllowedLevel = 100;
    if (sTag == "REB") iMaxAllowedLevel = 100;
    if (sTag == "REDDRAGONGAURDIAN") iMaxAllowedLevel = 100;
    if (sTag == "REDDWARF") iMaxAllowedLevel = 100;
    if (sTag == "RETIREDFIGHTER") iMaxAllowedLevel = 100;
    if (sTag == "RONUS") iMaxAllowedLevel = 100;
    if (sTag == "SERF") iMaxAllowedLevel = 100;
    if (sTag == "SHOGUNMUSCLE") iMaxAllowedLevel = 100;
    if (sTag == "SHUGONSHURIKEN") iMaxAllowedLevel = 100;
    if (sTag == "SHOGUNWARRIOR") iMaxAllowedLevel = 100;
    if (sTag == "SOUTHKEEPEROFKEYS") iMaxAllowedLevel = 100;
    if (sTag == "THRULITH") iMaxAllowedLevel = 100;
    if (sTag == "THUNDERLORD") iMaxAllowedLevel = 100;
    if (sTag == "TMGAURD") iMaxAllowedLevel = 100;
    if (sTag == "TMJAILOR") iMaxAllowedLevel = 100;
    if (sTag == "TREVILANCE") iMaxAllowedLevel = 100;
    if (sTag == "VERAN") iMaxAllowedLevel = 100;
    if (sTag == "VOIDMONK") iMaxAllowedLevel = 100;
    if (sTag == "WESTKEEPEROFKEYS") iMaxAllowedLevel = 100;
    if (sTag == "WITCH") iMaxAllowedLevel = 100;
    if (sTag == "ZACHARDTHEGREAT") iMaxAllowedLevel = 100;
    if (sTag == "MASTERCAIN") iMaxAllowedLevel = 100;
    if (sTag == "DUNELORD") iMaxAllowedLevel = 100;
    if (sTag == "QUEENDUERGER") iMaxAllowedLevel = 100;
    if (sTag == "WEREWOLF") iMaxAllowedLevel = 100;
    if (sTag == "DWARFBOSS01") iMaxAllowedLevel = 100;
    if (sTag == "DWARFBOSS02") iMaxAllowedLevel = 100;
    if (sTag == "DEADHEAD") iMaxAllowedLevel = 15;
    if (sTag == "GRANOLA") iMaxAllowedLevel = 18;
    if (sTag == "PAWNTAKER") iMaxAllowedLevel = 100;
    if (sTag == "LIZARDBOSS") iMaxAllowedLevel = 18;
    if (sTag == "TMBOSSCHEST_01") iMaxAllowedLevel = 100;
    if (sTag == "TMBOSSCHEST_02") iMaxAllowedLevel = 100;
    if (sTag == "DANCINGSWORDS") iMaxAllowedLevel = 100;
    if (sTag == "FLOATINGSCIMITAR") iMaxAllowedLevel = 100;
    if (sTag == "AIRKEEPER") iMaxAllowedLevel = 100;
    if (sTag == "WATERKEEPER") iMaxAllowedLevel = 100;
    if (sTag == "EARTHKEEPER") iMaxAllowedLevel = 100;
    if (sTag == "LORDOFCHAOS") iMaxAllowedLevel = 100;
    if (sTag == "WARMACHINE") iMaxAllowedLevel = 100;
    if (sTag == "DEAMONSORCERER") iMaxAllowedLevel = 100;
    if (sTag == "FLOATINGBOW") iMaxAllowedLevel = 100;
    if (sTag == "CAINWARRIOR") iMaxAllowedLevel = 100;
    if (sTag == "CAINMAGE") iMaxAllowedLevel = 100;
    if (sTag == "CAINSENIORMAGE") iMaxAllowedLevel = 100;
    if (sTag == "SETH") iMaxAllowedLevel = 100;
    if (sTag == "BARBARIANOUTCAST") iMaxAllowedLevel = 100;
    if (sTag == "ASYRIANHOLYMAN") iMaxAllowedLevel = 100;
    if (sTag == "ASYRIANAXEMAN") iMaxAllowedLevel = 100;
    if (sTag == "ASYRIANSPEARMEN") iMaxAllowedLevel = 100;
    if (sTag == "IRONRANGE") iMaxAllowedLevel = 100;
    if (sTag == "MRINFERNO") iMaxAllowedLevel = 100;
    if (sTag == "MRISSAC") iMaxAllowedLevel = 100;
    if (sTag == "OZKNIGHT") iMaxAllowedLevel = 100;
    if (sTag == "LEGIONARCHER") iMaxAllowedLevel = 100;
    if (sTag == "LEGIONASSASSIN") iMaxAllowedLevel = 100;
    if (sTag == "IRONMINOTAUR") iMaxAllowedLevel = 100;
    if (sTag == "SHADOWLEGIONRANGER") iMaxAllowedLevel = 100;
    if (sTag == "LEGIONWARRIOR") iMaxAllowedLevel = 100;
    if (sTag == "LUCEPH") iMaxAllowedLevel = 100;
    if (sTag == "LUCEPHCAPTIAN") iMaxAllowedLevel = 100;
    if (sTag == "ASYRIANMASTERCRAFTSMAN") iMaxAllowedLevel = 100;
    if (sTag == "OZKING") iMaxAllowedLevel = 100;
    if (sTag == "MASTERASSASSIN") iMaxAllowedLevel = 100;
    if (sTag == "ASYRIANTREASUREGAURD") iMaxAllowedLevel = 100;
    if (sTag == "GRANOLADRUID") iMaxAllowedLevel = 100;
    if (sTag == "ANGUIS") iMaxAllowedLevel = 100;
    if (sTag == "ELRIEOFTHEMYSTIC") iMaxAllowedLevel = 100;
    if (sTag == "RAIDERLEADER") iMaxAllowedLevel = 100;
    if (sTag == "ZACHASAURUS") iMaxAllowedLevel = 100;
    return iMaxAllowedLevel;
}


//:://////////////////////////////////////////////
//::        Function - GetMinimumLevel
//:://////////////////////////////////////////////
/*
                Function Description

Use this function to set the minimum level at which
a party member could reasonably contribute enough
to generate treasure. For example, if the party has
just tackled a CR 15 monster, chances are the level 1
guy tagging along didn't do anything to help, so he
doesn't deserve to have treasure generated for him.

Each item that generates a unique treasure should
have an entry in this table. If a match is not found
the function will return 0 - but this is not a good
thing because that means a bunch of level 1s can tag
along and generate tons of treasure.

*/

int GetMinimumLevel (object oCaller)
{
    int iMinimumLevel = 0;
    string sTag = GetTag (oCaller);

    if (sTag == "AIRELEMENTAL") iMinimumLevel = 1;
    if (sTag == "ANCIENTBLACKDRAGON") iMinimumLevel = 10;
    if (sTag == "ANCIENTBRONZEDRAGON") iMinimumLevel = 10;
    if (sTag == "ANCIENTCOPPERDRAGON") iMinimumLevel = 10;
    if (sTag == "ANCIENTGREENDRAGON") iMinimumLevel = 10;
    if (sTag == "ANCIENTREDDRAGON") iMinimumLevel = 10;
    if (sTag == "ANCIENTSILVERDRAGON") iMinimumLevel = 10;
    if (sTag == "ANCIENTWHITEDRAGON") iMinimumLevel = 10;
    if (sTag == "ANIMALMASTER") iMinimumLevel = 10;
    if (sTag == "ARENACHAMPION") iMinimumLevel = 15;
    if (sTag == "BABYREDDRAGON") iMinimumLevel = 1;
    if (sTag == "BANDITCHIEF") iMinimumLevel = 1;
    if (sTag == "BALKER") iMinimumLevel = 1;
    if (sTag == "BALORLORD") iMinimumLevel = 10;
    if (sTag == "BANDIT") iMinimumLevel = 1;
    if (sTag == "BANDITARCHER") iMinimumLevel = 1;
    if (sTag == "BANDITMAGE") iMinimumLevel = 1;
    if (sTag == "BANDITROGUE") iMinimumLevel = 1;
    if (sTag == "BARROCK") iMinimumLevel = 10;
    if (sTag == "BIKINIMONK") iMinimumLevel = 15;
    if (sTag == "BLACKDRAGONGAURDIAN") iMinimumLevel = 10;
    if (sTag == "BLUEDWARF") iMinimumLevel = 18;
    if (sTag == "BRIGGS") iMinimumLevel = 18;
    if (sTag == "BUDOC") iMinimumLevel = 15;
    if (sTag == "CAINWARRIOR") iMinimumLevel = 15;
    if (sTag == "COPPERDRAGONGAURDIAN") iMinimumLevel = 15;
    if (sTag == "CULTDICIPLE") iMinimumLevel = 15;
    if (sTag == "CULTDICIPLESCOUT") iMinimumLevel = 15;
    if (sTag == "CULTLEADER") iMinimumLevel = 15;
    if (sTag == "CULTOFMINIMAGE") iMinimumLevel = 18;
    if (sTag == "CULTOFMINIWARRIOR") iMinimumLevel = 18;
    if (sTag == "CULTWARRIOR") iMinimumLevel = 15;
    if (sTag == "DRAKALM") iMinimumLevel = 15;
    if (sTag == "DUERGERMAGE") iMinimumLevel = 15;
    if (sTag == "DUERGERROGUE") iMinimumLevel = 15;
    if (sTag == "DUNEPRIEST") iMinimumLevel = 15;
    if (sTag == "DWARFBLADESLINGER") iMinimumLevel = 18;
    if (sTag == "DWARFHIGHWIZARD") iMinimumLevel = 18;
    if (sTag == "DWARFPRIEST") iMinimumLevel = 1;
    if (sTag == "EARTHELEMENTAL") iMinimumLevel = 1;
    if (sTag == "ELRIETHEMIGHTY") iMinimumLevel = 15;
    if (sTag == "EVILFAIRY") iMinimumLevel = 1;
    if (sTag == "FIREDRAGON") iMinimumLevel = 10;
    if (sTag == "FIREELEMENTAL") iMinimumLevel = 10;
    if (sTag == "GHOULLORD") iMinimumLevel = 1;
    if (sTag == "GIANTKEYKEEPER") iMinimumLevel = 1;
    if (sTag == "GIANTMAGE") iMinimumLevel = 1;
    if (sTag == "GLEBUR") iMinimumLevel = 18;
    if (sTag == "GREENDRAGONGAURDIAN") iMinimumLevel = 15;
    if (sTag == "GREENDWARF") iMinimumLevel = 18;
    if (sTag == "HALFBEASTRANGER") iMinimumLevel = 18;
    if (sTag == "HLAFBEASTWARRIOR") iMinimumLevel = 18;
    if (sTag == "HEARTLESS") iMinimumLevel = 10;
    if (sTag == "HOLOGAURD") iMinimumLevel = 1;
    if (sTag == "HOLO") iMinimumLevel = 1;
    if (sTag == "KEEPEROFKEYSEAST") iMinimumLevel = 10;
    if (sTag == "KINGDUERGER") iMinimumLevel = 1;
    if (sTag == "LIGHTINGDRAGON") iMinimumLevel = 10;
    if (sTag == "LIZARDCHIEF") iMinimumLevel = 1;
    if (sTag == "LORDSHACKNUK") iMinimumLevel = 15;
    if (sTag == "MALCOM") iMinimumLevel = 1;
    if (sTag == "MALCOMPROTECTOR") iMinimumLevel = 1;
    if (sTag == "MERCENARY") iMinimumLevel = 1;
    if (sTag == "METALMONK") iMinimumLevel = 1;
    if (sTag == "MINGTAO") iMinimumLevel = 15;
    if (sTag == "MINIMONK") iMinimumLevel = 15;
    if (sTag == "MONKOSAURUS") iMinimumLevel = 15;
    if (sTag == "MONXIE") iMinimumLevel = 15;
    if (sTag == "MRROBATO") iMinimumLevel = 1;
    if (sTag == "MUMMYWARRIOR") iMinimumLevel = 1;
    if (sTag == "NAMELESSCULTPRIEST") iMinimumLevel = 1;
    if (sTag == "NORTHKEEPEROFKEYS") iMinimumLevel = 15;
    if (sTag == "ORC_ARCHER") iMinimumLevel = 1;
    if (sTag == "ORC_CHAMP") iMinimumLevel = 1;
    if (sTag == "ORC_CHIEF") iMinimumLevel = 1;
    if (sTag == "ORC_BOSS") iMinimumLevel = 1;
    if (sTag == "QUEENDUERGER") iMinimumLevel = 1;
    if (sTag == "RAINMAKER") iMinimumLevel = 1;
    if (sTag == "REB") iMinimumLevel = 18;
    if (sTag == "REDDRAGONGAURDIAN") iMinimumLevel = 15;
    if (sTag == "REDDWARF") iMinimumLevel = 18;
    if (sTag == "RETIREDFIGHTER") iMinimumLevel = 15;
    if (sTag == "RONUS") iMinimumLevel = 18;
    if (sTag == "SERF") iMinimumLevel = 18;
    if (sTag == "SHOGUNMUSCLE") iMinimumLevel = 1;
    if (sTag == "SHUGONSHURIKEN") iMinimumLevel = 1;
    if (sTag == "SHOGUNWARRIOR") iMinimumLevel = 5;
    if (sTag == "SOUTHKEEPEROFKEYS") iMinimumLevel = 15;
    if (sTag == "THRULITH") iMinimumLevel = 1;
    if (sTag == "THUNDERLORD") iMinimumLevel = 15;
    if (sTag == "TMGAURD") iMinimumLevel = 10;
    if (sTag == "TMJAILOR") iMinimumLevel = 15;
    if (sTag == "TREVILANCE") iMinimumLevel = 15;
    if (sTag == "VERAN") iMinimumLevel = 15;
    if (sTag == "VOIDMONK") iMinimumLevel = 15;
    if (sTag == "WESTKEEPEROFKEYS") iMinimumLevel = 15;
    if (sTag == "WITCH") iMinimumLevel = 1;
    if (sTag == "ZACHARDTHEGREAT") iMinimumLevel = 15;
    if (sTag == "MASTERCAIN") iMinimumLevel = 18;
    if (sTag == "DUNELORD") iMinimumLevel = 10;
    if (sTag == "QUEENDUERGER") iMinimumLevel = 1;
    if (sTag == "WEREWOLF") iMinimumLevel = 15;
    if (sTag == "DWARFBOSS01") iMinimumLevel = 18;
    if (sTag == "DWARFBOSS02") iMinimumLevel = 18;
    if (sTag == "DEADHEAD") iMinimumLevel = 1;
    if (sTag == "GRANOLA") iMinimumLevel = 1;
    if (sTag == "PAWNTAKER") iMinimumLevel = 15;
    if (sTag == "LIZARDBOSS") iMinimumLevel = 15;
    if (sTag == "TMBOSSCHEST_01") iMinimumLevel = 12;
    if (sTag == "TMBOSSCHEST_02") iMinimumLevel = 12;
    if (sTag == "REDPOWDERCHEST") iMinimumLevel = 1;
    if (sTag == "DANCINGSWORDS") iMinimumLevel = 18;
    if (sTag == "FLOATINGSCIMITAR") iMinimumLevel = 18;
    if (sTag == "AIRKEEPER") iMinimumLevel = 18;
    if (sTag == "WATERKEEPER") iMinimumLevel = 18;
    if (sTag == "EARTHKEEPER") iMinimumLevel = 18;
    if (sTag == "LORDOFCHAOS") iMinimumLevel = 18;
    if (sTag == "WARMACHINE") iMinimumLevel = 18;
    if (sTag == "DEAMONSORCERER") iMinimumLevel = 18;
    if (sTag == "FLOATINGBOW") iMinimumLevel = 18;
    if (sTag == "CAINWARRIOR") iMinimumLevel = 18;
    if (sTag == "CAINMAGE") iMinimumLevel = 18;
    if (sTag == "CAINSENIORMAGE") iMinimumLevel = 18;
    if (sTag == "SETH") iMinimumLevel = 18;
    if (sTag == "BARBARIANOUTCAST") iMinimumLevel = 1;
    if (sTag == "ASYRIANHOLYMAN") iMinimumLevel = 15;
    if (sTag == "ASYRIANAXEMAN") iMinimumLevel = 15;
    if (sTag == "ASYRIANSPEARMEN") iMinimumLevel = 15;
    if (sTag == "IRONRANGE") iMinimumLevel = 15;
    if (sTag == "MRINFERNO") iMinimumLevel = 15;
    if (sTag == "MRISSAC") iMinimumLevel = 15;
    if (sTag == "OZKNIGHT") iMinimumLevel = 15;
    if (sTag == "LEGIONARCHER") iMinimumLevel = 15;
    if (sTag == "LEGIONASSASSIN") iMinimumLevel = 15;
    if (sTag == "IRONMINOTAUR") iMinimumLevel = 15;
    if (sTag == "SHADOWLEGIONRANGER") iMinimumLevel = 5;
    if (sTag == "LEGIONWARRIOR") iMinimumLevel = 15;
    if (sTag == "LUCEPH") iMinimumLevel = 15;
    if (sTag == "LUCEPHCAPTIAN") iMinimumLevel = 15;
    if (sTag == "ASYRIANMASTERCRAFTSMAN") iMinimumLevel = 15;
    if (sTag == "OZKING") iMinimumLevel = 15;
    if (sTag == "MASTERASSASSIN") iMinimumLevel = 15;
    if (sTag == "ASYRIANTREASUREGAURD") iMinimumLevel = 15;
    if (sTag == "GRANOLADRUID") iMinimumLevel = 1;
    if (sTag == "ANGUIS") iMinimumLevel = 15;
    if (sTag == "ELRIEOFTHEMYSTIC") iMinimumLevel = 1;
    if (sTag == "RAIDERLEADER") iMinimumLevel = 1;
    if (sTag == "ZACHASAURUS") iMinimumLevel = 18;
    return iMinimumLevel;
}


//:://////////////////////////////////////////////
//::        Function
//:://////////////////////////////////////////////
/*
                Function Description

This sets the respawn time for chests. It is area wide,
although you can override the respawn time on a given
chest by adding an entry based on the items tag. in the
second part of the function.

Default is an hour.

*/


float GetRespawnTime (object oCaller)
{

    float fRespawnTime = 1200.00;
    string sTag = GetTag (oCaller);
    string sAreaTag = GetTag(GetArea(oCaller));

    // Add your area wide respawn times here.

    if (sAreaTag == "TamaraCoast") fRespawnTime = 90.00;

    // Set the respawn time by the object's tag instead.

    if (sTag == "AIRELEMENTAL") fRespawnTime = 60.00;
    if (sTag == "ANCIENTBLACKDRAGON") fRespawnTime = 60.00;
    if (sTag == "ANCIENTBRONZEDRAGON") fRespawnTime = 60.00;
    if (sTag == "ANCIENTCOPPERDRAGON") fRespawnTime = 60.00;
    if (sTag == "ANCIENTGREENDRAGON") fRespawnTime = 60.00;
    if (sTag == "ANCIENTREDDRAGON") fRespawnTime = 60.00;
    if (sTag == "ANCIENTSILVERDRAGON") fRespawnTime = 60.00;
    if (sTag == "ANCIENTWHITEDRAGON") fRespawnTime = 60.00;
    if (sTag == "ANIMALMASTER") fRespawnTime = 60.00;
    if (sTag == "ARENACHAMPION") fRespawnTime = 60.00;
    if (sTag == "BABYREDDRAGON") fRespawnTime = 60.00;
    if (sTag == "BANDITCHIEF") fRespawnTime = 60.00;
    if (sTag == "BALKER") fRespawnTime = 60.00;
    if (sTag == "BALORLORD") fRespawnTime = 60.00;
    if (sTag == "BANDIT") fRespawnTime = 60.00;
    if (sTag == "BANDITARCHER") fRespawnTime = 60.00;
    if (sTag == "BANDITMAGE") fRespawnTime = 60.00;
    if (sTag == "BANDITROGUE") fRespawnTime = 60.00;
    if (sTag == "BARROCK") fRespawnTime = 60.00;
    if (sTag == "BIKINIMONK") fRespawnTime = 60.00;
    if (sTag == "BLACKDRAGONGAURDIAN") fRespawnTime = 60.00;
    if (sTag == "BLUEDWARF") fRespawnTime = 60.00;
    if (sTag == "BRIGGS") fRespawnTime = 60.00;
    if (sTag == "BUDOC") fRespawnTime = 60.00;
    if (sTag == "CAINWARRIOR") fRespawnTime = 60.00;
    if (sTag == "COPPERDRAGONGAURDIAN") fRespawnTime = 60.00;
    if (sTag == "CULTDICIPLE") fRespawnTime = 60.00;
    if (sTag == "CULTDICIPLESCOUT") fRespawnTime = 60.00;
    if (sTag == "CULTLEADER") fRespawnTime = 60.00;
    if (sTag == "CULTOFMINIMAGE") fRespawnTime = 60.00;
    if (sTag == "CULTOFMINIWARRIOR") fRespawnTime = 60.00;
    if (sTag == "CULTWARRIOR") fRespawnTime = 60.00;
    if (sTag == "DRAKALM") fRespawnTime = 60.00;
    if (sTag == "DUERGERMAGE") fRespawnTime = 60.00;
    if (sTag == "DUERGERROGUE") fRespawnTime = 60.00;
    if (sTag == "DUNEPRIEST") fRespawnTime = 60.00;
    if (sTag == "DWARFBLADESLINGER") fRespawnTime = 60.00;
    if (sTag == "DWARFHIGHWIZARD") fRespawnTime = 60.00;
    if (sTag == "DWARFPRIEST") fRespawnTime = 60.00;
    if (sTag == "EARTHELEMENTAL") fRespawnTime = 60.00;
    if (sTag == "ELRIETHEMIGHTY") fRespawnTime = 60.00;
    if (sTag == "EVILFAIRY") fRespawnTime = 60.00;
    if (sTag == "FIREDRAGON") fRespawnTime = 60.00;
    if (sTag == "FIREELEMENTAL") fRespawnTime = 60.00;
    if (sTag == "GHOULLORD") fRespawnTime = 60.00;
    if (sTag == "GIANTKEYKEEPER") fRespawnTime = 60.00;
    if (sTag == "GIANTMAGE") fRespawnTime = 60.00;
    if (sTag == "GLEBUR") fRespawnTime = 60.00;
    if (sTag == "GREENDRAGONGAURDIAN") fRespawnTime = 60.00;
    if (sTag == "GREENDWARF") fRespawnTime = 60.00;
    if (sTag == "HALFBEASTRANGER") fRespawnTime = 60.00;
    if (sTag == "HLAFBEASTWARRIOR") fRespawnTime = 60.00;
    if (sTag == "HEARTLESS") fRespawnTime = 60.00;
    if (sTag == "HOLOGAURD") fRespawnTime = 60.00;
    if (sTag == "HOLO") fRespawnTime = 60.00;
    if (sTag == "KEEPEROFKEYSEAST") fRespawnTime = 60.00;
    if (sTag == "KINGDUERGER") fRespawnTime = 60.00;
    if (sTag == "LIGHTINGDRAGON") fRespawnTime = 60.00;
    if (sTag == "LIZARDCHIEF") fRespawnTime = 60.00;
    if (sTag == "LORDSHACKNUK") fRespawnTime = 60.00;
    if (sTag == "MALCOM") fRespawnTime = 60.00;
    if (sTag == "MALCOMPROTECTOR") fRespawnTime = 60.00;
    if (sTag == "MERCENARY") fRespawnTime = 60.00;
    if (sTag == "METALMONK") fRespawnTime = 60.00;
    if (sTag == "MINGTAO") fRespawnTime = 60.00;
    if (sTag == "MINIMONK") fRespawnTime = 60.00;
    if (sTag == "MONKOSAURUS") fRespawnTime = 60.00;
    if (sTag == "MONXIE") fRespawnTime = 60.00;
    if (sTag == "MRROBATO") fRespawnTime = 60.00;
    if (sTag == "MUMMYWARRIOR") fRespawnTime = 60.00;
    if (sTag == "NAMELESSCULTPRIEST") fRespawnTime = 60.00;
    if (sTag == "NORTHKEEPEROFKEYS") fRespawnTime = 60.00;
    if (sTag == "ORC_ARCHER") fRespawnTime = 60.00;
    if (sTag == "ORC_CHAMP") fRespawnTime = 60.00;
    if (sTag == "ORC_CHIEF") fRespawnTime = 60.00;
    if (sTag == "ORC_BOSS") fRespawnTime = 60.00;
    if (sTag == "QUEENDUERGER") fRespawnTime = 60.00;
    if (sTag == "RAINMAKER") fRespawnTime = 60.00;
    if (sTag == "REB") fRespawnTime = 60.00;
    if (sTag == "REDDRAGONGAURDIAN") fRespawnTime = 60.00;
    if (sTag == "REDDWARF") fRespawnTime = 60.00;
    if (sTag == "RETIREDFIGHTER") fRespawnTime = 60.00;
    if (sTag == "RONUS") fRespawnTime = 60.00;
    if (sTag == "SERF") fRespawnTime = 60.00;
    if (sTag == "SHOGUNMUSCLE") fRespawnTime = 60.00;
    if (sTag == "SHUGONSHURIKEN") fRespawnTime = 60.00;
    if (sTag == "SHOGUNWARRIOR") fRespawnTime = 60.00;
    if (sTag == "SOUTHKEEPEROFKEYS") fRespawnTime = 60.00;
    if (sTag == "THRULITH") fRespawnTime = 60.00;
    if (sTag == "THUNDERLORD") fRespawnTime = 60.00;
    if (sTag == "TMGAURD") fRespawnTime = 60.00;
    if (sTag == "TMJAILOR") fRespawnTime = 60.00;
    if (sTag == "TREVILANCE") fRespawnTime = 60.00;
    if (sTag == "VERAN") fRespawnTime = 60.00;
    if (sTag == "VOIDMONK") fRespawnTime = 60.00;
    if (sTag == "WESTKEEPEROFKEYS") fRespawnTime = 60.00;
    if (sTag == "WITCH") fRespawnTime = 60.00;
    if (sTag == "ZACHARDTHEGREAT") fRespawnTime = 60.00;
    if (sTag == "MASTERCAIN") fRespawnTime = 60.00;
    if (sTag == "DUNELORD") fRespawnTime = 60.00;
    if (sTag == "QUEENDUERGER") fRespawnTime = 60.00;
    if (sTag == "WEREWOLF") fRespawnTime = 60.00;
    if (sTag == "DWARFBOSS01") fRespawnTime = 600.00;
    if (sTag == "DWARFBOSS02") fRespawnTime = 600.00;
    if (sTag == "DEADHEAD") fRespawnTime = 60.00;
    if (sTag == "GRANOLA") fRespawnTime = 60.00;
    if (sTag == "PAWNTAKER") fRespawnTime = 60.00;
    if (sTag == "LIZARDBOSS") fRespawnTime = 60.00;
    if (sTag == "TMBOSSCHEST_01") fRespawnTime = 600.00;
    if (sTag == "TMBOSSCHEST_02") fRespawnTime = 600.00;
    if (sTag == "REDPOWDERCHEST") fRespawnTime = 600.00;
    if (sTag == "DANCINGSWORDS") fRespawnTime = 60.00;
    if (sTag == "FLOATINGSCIMITAR") fRespawnTime = 60.00;
    if (sTag == "AIRKEEPER") fRespawnTime = 60.00;
    if (sTag == "WATERKEEPER") fRespawnTime = 60.00;
    if (sTag == "EARTHKEEPER") fRespawnTime = 60.00;
    if (sTag == "LORDOFCHAOS") fRespawnTime = 60.00;
    if (sTag == "WARMACHINE") fRespawnTime = 60.00;
    if (sTag == "DEAMONSORCERER") fRespawnTime = 60.00;
    if (sTag == "FLOATINGBOW") fRespawnTime = 60.00;
    if (sTag == "CAINWARRIOR") fRespawnTime = 60.00;
    if (sTag == "CAINMAGE") fRespawnTime = 60.00;
    if (sTag == "CAINSENIORMAGE") fRespawnTime = 60.00;
    if (sTag == "SETH") fRespawnTime = 60.00;
    if (sTag == "BARBARIANOUTCAST") fRespawnTime = 60.00;
    if (sTag == "ASYRIANHOLYMAN") fRespawnTime = 60.00;
    if (sTag == "ASYRIANAXEMAN") fRespawnTime = 60.00;
    if (sTag == "ASYRIANSPEARMEN") fRespawnTime = 60.00;
    if (sTag == "IRONRANGE") fRespawnTime = 60.00;
    if (sTag == "MRINFERNO") fRespawnTime = 60.00;
    if (sTag == "MRISSAC") fRespawnTime = 60.00;
    if (sTag == "OZKNIGHT") fRespawnTime = 60.00;
    if (sTag == "LEGIONARCHER") fRespawnTime = 60.00;
    if (sTag == "LEGIONASSASSIN") fRespawnTime = 60.00;
    if (sTag == "IRONMINOTAUR") fRespawnTime = 60.00;
    if (sTag == "SHADOWLEGIONRANGER") fRespawnTime = 60.00;
    if (sTag == "LEGIONWARRIOR") fRespawnTime = 60.00;
    if (sTag == "LUCEPH") fRespawnTime = 60.00;
    if (sTag == "LUCEPHCAPTIAN") fRespawnTime = 60.00;
    if (sTag == "ASYRIANMASTERCRAFTSMAN") fRespawnTime = 60.00;
    if (sTag == "OZKING") fRespawnTime = 60.00;
    if (sTag == "MASTERASSASSIN") fRespawnTime = 60.00;
    if (sTag == "ASYRIANTREASUREGAURD") fRespawnTime = 60.00;
    if (sTag == "GRANOLADRUID") fRespawnTime = 60.00;
    if (sTag == "ANGUIS") fRespawnTime = 60.00;
    if (sTag == "ELRIEOFTHEMYSTIC") fRespawnTime = 60.00;
    if (sTag == "RAIDERLEADER") fRespawnTime = 60.00;
    if (sTag == "ZACHASAURUS") fRespawnTime = 60.00;

    return fRespawnTime;
}

//:://////////////////////////////////////////////
//:: Function - GetMinimumNumberOfItemsToGenerate
//:://////////////////////////////////////////////
/*
                Function Description

This sets the minimum number of items that a specific
boss loot will generate. In the if statement, include
a statement referencing the tag of the item containing
the loot.

Default is one item.

*/

int GetMinimumNumberOfItemsToGenerate (object oCaller)
{
    int iMinimumNumberOfItemsToGenerate = 1;
    string sTag = GetTag(oCaller);

    if (sTag == "AIRELEMENTAL") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ANCIENTBLACKDRAGON") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ANCIENTBRONZEDRAGON") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ANCIENTCOPPERDRAGON") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ANCIENTGREENDRAGON") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ANCIENTREDDRAGON") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ANCIENTSILVERDRAGON") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ANCIENTWHITEDRAGON") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ANIMALMASTER") iMinimumNumberOfItemsToGenerate = 2;
    if (sTag == "ARENACHAMPION") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BABYREDDRAGON") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BANDITCHIEF") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BALKER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BALORLORD") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BANDIT") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BANDITARCHER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BANDITMAGE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BANDITROGUE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BARROCK") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BIKINIMONK") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BLACKDRAGONGAURDIAN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BLUEDWARF") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "BUDOC") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "CAINWARRIOR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "COPPERDRAGONGAURDIAN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "CULTDICIPLE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "CULTDICIPLESCOUT") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "CULTLEADER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "CULTOFMINIMAGE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "CULTOFMINIWARRIOR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "CULTWARRIOR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "DRAKALM") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "DUERGERMAGE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "DUERGERROGUE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "DUNEPRIEST") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "DWARFBLADESLINGER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "DWARFHIGHWIZARD") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "DWARFPRIEST") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "EARTHELEMENTAL") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ELRIETHEMIGHTY") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "EVILFAIRY") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "FIREDRAGON") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "FIREELEMENTAL") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "GHOULLORD") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "GIANTKEYKEEPER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "GIANTMAGE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "GLEBUR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "GREENDRAGONGAURDIAN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "GREENDWARF") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "HALFBEASTRANGER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "HLAFBEASTWARRIOR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "HEARTLESS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "HOLOGAURD") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "HOLO") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "KEEPEROFKEYSEAST") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "KINGDUERGER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "LIGHTINGDRAGON") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "LIZARDCHIEF") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "LORDSHACKNUK") iMinimumNumberOfItemsToGenerate = 2;
    if (sTag == "MALCOM") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MALCOMPROTECTOR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MERCENARY") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "METALMONK") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MINGTAO") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MINIMONK") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MONKOSAURUS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MONXIE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MRROBATO") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MUMMYWARRIOR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "NAMELESSCULTPRIEST") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "NORTHKEEPEROFKEYS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ORC_ARCHER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ORC_CHAMP") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ORC_CHIEF") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ORC_BOSS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "QUEENDUERGER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "RAINMAKER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "REB") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "REDDRAGONGAURDIAN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "REDDWARF") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "RETIREDFIGHTER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "RONUS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "SERF") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "SHOGUNMUSCLE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "SHUGONSHURIKEN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "SHOGUNWARRIOR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "SOUTHKEEPEROFKEYS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "THRULITH") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "THUNDERLORD") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "TMGAURD") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "TMJAILOR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "TREVILANCE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "VERAN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "VOIDMONK") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "WESTKEEPEROFKEYS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "WITCH") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ZACHARDTHEGREAT") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MASTERCAIN") iMinimumNumberOfItemsToGenerate = 3;
    if (sTag == "DUNELORD") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "QUEENDUERGER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "WEREWOLF") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "DWARFBOSS01") iMinimumNumberOfItemsToGenerate = 4;
    if (sTag == "DWARFBOSS02") iMinimumNumberOfItemsToGenerate = 4;
    if (sTag == "DEADHEAD") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "GRANOLA") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "PAWNTAKER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "LIZARDBOSS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "TMBOSSCHEST_01") iMinimumNumberOfItemsToGenerate = 2;
    if (sTag == "TMBOSSCHEST_02") iMinimumNumberOfItemsToGenerate = 2;
    if (sTag == "REDPOWDERCHEST") iMinimumNumberOfItemsToGenerate = 2;
    if (sTag == "DANCINGSWORDS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "FLOATINGSCIMITAR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "AIRKEEPER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "WATERKEEPER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "EARTHKEEPER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "LORDOFCHAOS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "WARMACHINE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "DEAMONSORCERER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "FLOATINGBOW") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "CAINWARRIOR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "CAINMAGE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "CAINSENIORMAGE") iMinimumNumberOfItemsToGenerate = 2;
    if (sTag == "SETH") iMinimumNumberOfItemsToGenerate = 3;
    if (sTag == "BARBARIANOUTCAST") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ASYRIANHOLYMAN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ASYRIANAXEMAN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ASYRIANSPEARMEN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "IRONRANGE") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MRINFERNO") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MRISSAC") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "OZKNIGHT") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "LEGIONARCHER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "LEGIONASSASSIN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "IRONMINOTAUR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "SHADOWLEGIONRANGER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "LEGIONWARRIOR") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "LUCEPH") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "LUCEPHCAPTIAN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ASYRIANMASTERCRAFTSMAN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "OZKING") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "MASTERASSASSIN") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ASYRIANTREASUREGAURD") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "GRANOLADRUID") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ANGUIS") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ELRIEOFTHEMYSTIC") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "RAIDERLEADER") iMinimumNumberOfItemsToGenerate = 1;
    if (sTag == "ZACHASAURUS") iMinimumNumberOfItemsToGenerate = 1;

    return iMinimumNumberOfItemsToGenerate;
}

//:://////////////////////////////////////////////
//:: Function - GetMaximumNumberOfItemsToGenerate
//:://////////////////////////////////////////////
/*
                Function Description

This sets the maximum number of items that a specific
boss loot will generate. In the if statement, include
a statement referencing the tag of the item containing
the loot.

Default is four items.

*/

int GetMaximumNumberOfItemsToGenerate (object oCaller)
{
    int iMaximumNumberOfItemsToGenerate = 2;
    string sTag = GetTag(oCaller);

    if (sTag == "AIRELEMENTAL") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ANCIENTBLACKDRAGON") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ANCIENTBRONZEDRAGON") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ANCIENTCOPPERDRAGON") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ANCIENTGREENDRAGON") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ANCIENTREDDRAGON") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ANCIENTSILVERDRAGON") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ANCIENTWHITEDRAGON") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ANIMALMASTER") iMaximumNumberOfItemsToGenerate = 4;
    if (sTag == "ARENACHAMPION") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BABYREDDRAGON") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BANDITCHIEF") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BALKER") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "BALORLORD") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BANDIT") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BANDITARCHER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BANDITMAGE") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BANDITROGUE") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BARROCK") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BIKINIMONK") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BLACKDRAGONGAURDIAN") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BLUEDWARF") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BRIGGS") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BUDOC") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "CAINWARRIOR") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "COPPERDRAGONGAURDIAN") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "CULTDICIPLE") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "CULTDICIPLESCOUT") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "CULTLEADER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "CULTOFMINIMAGE") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "CULTOFMINIWARRIOR") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "CULTWARRIOR") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "DRAKALM") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "DUERGERMAGE") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "DUERGERROGUE") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "DUNEPRIEST") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "DWARFBLADESLINGER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "DWARFHIGHWIZARD") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "DWARFPRIEST") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "EARTHELEMENTAL") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ELRIETHEMIGHTY") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "EVILFAIRY") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "FIREDRAGON") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "FIREELEMENTAL") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "GHOULLORD") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "GIANTKEYKEEPER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "GIANTMAGE") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "GLEBUR") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "GREENDRAGONGAURDIAN") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "GREENDWARF") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "HALFBEASTRANGER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "HLAFBEASTWARRIOR") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "HEARTLESS") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "HOLOGAURD") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "HOLO") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "KEEPEROFKEYSEAST") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "KINGDUERGER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "LIGHTINGDRAGON") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "LIZARDCHIEF") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "LORDSHACKNUK") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "MALCOM") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "MALCOMPROTECTOR") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "MERCENARY") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "METALMONK") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "MINGTAO") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "MINIMONK") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "MONKOSAURUS") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "MONXIE") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "MRROBATO") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "MUMMYWARRIOR") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "NAMELESSCULTPRIEST") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "NORTHKEEPEROFKEYS") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ORC_ARCHER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ORC_CHAMP") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ORC_CHIEF") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ORC_BOSS") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "QUEENDUERGER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "RAINMAKER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "REB") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "REDDRAGONGAURDIAN") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "REDDWARF") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "RETIREDFIGHTER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "RONUS") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "SERF") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "SHOGUNMUSCLE") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "SHUGONSHURIKEN") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "SHOGUNWARRIOR") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "SOUTHKEEPEROFKEYS") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "THRULITH") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "THUNDERLORD") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "TMGAURD") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "TMJAILOR") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "TREVILANCE") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "VERAN") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "VOIDMONK") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "WESTKEEPEROFKEYS") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "WITCH") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ZACHARDTHEGREAT") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "MASTERCAIN") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "DUNELORD") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "QUEENDUERGER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "WEREWOLF") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "DWARFBOSS01") iMaximumNumberOfItemsToGenerate = 6;
    if (sTag == "DWARFBOSS02") iMaximumNumberOfItemsToGenerate = 6;
    if (sTag == "DEADHEAD") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "GRANOLA") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "PAWNTAKER") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "LIZARDBOSS") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "TMBOSSCHEST_01") iMaximumNumberOfItemsToGenerate = 4;
    if (sTag == "TMBOSSCHEST_02") iMaximumNumberOfItemsToGenerate = 4;
    if (sTag == "REDPOWDERCHEST") iMaximumNumberOfItemsToGenerate = 4;
    if (sTag == "DANCINGSWORDS") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "FLOATINGSCIMITAR") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "AIRKEEPER") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "WATERKEEPER") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "EARTHKEEPER") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "LORDOFCHAOS") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "WARMACHINE") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "DEAMONSORCERER") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "FLOATINGBOW") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "CAINWARRIOR") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "CAINMAGE") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "CAINSENIORMAGE") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "SETH") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "BARBARIANOUTCAST") iMaximumNumberOfItemsToGenerate = 2;
    if (sTag == "ASYRIANHOLYMAN") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "ASYRIANAXEMAN") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "ASYRIANSPEARMEN") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "IRONRANGE") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "MRINFERNO") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "MRISSAC") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "OZKNIGHT") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "LEGIONARCHER") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "LEGIONASSASSIN") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "IRONMINOTAUR") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "SHADOWLEGIONRANGER") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "LEGIONWARRIOR") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "LUCEPH") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "LUCEPHCAPTIAN") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "ASYRIANMASTERCRAFTSMAN") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "OZKING") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "MASTERASSASSIN") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "ASYRIANTREASUREGAURD") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "GRANOLADRUID") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "ANGUIS") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "ELRIEOFTHEMYSTIC") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "RAIDERLEADER") iMaximumNumberOfItemsToGenerate = 1;
    if (sTag == "ZACHASAURUS") iMaximumNumberOfItemsToGenerate = 1;

    return iMaximumNumberOfItemsToGenerate;
}




//:://////////////////////////////////////////////
//::        Function - GetTotalAvailableItems
//:://////////////////////////////////////////////
/*
                Function Description

This function returns simply returns the number of items
available on a boss's treasure table. Default is 1.

*/

int GetTotalAvailableItems (object oCaller)
{
    string sTag = GetTag (oCaller);
    int iNumItems = 1;

    if (sTag == "AIRELEMENTAL") iNumItems = 2;
    if (sTag == "ANCIENTBLACKDRAGON") iNumItems = 2;
    if (sTag == "ANCIENTBRONZEDRAGON") iNumItems = 2;
    if (sTag == "ANCIENTCOPPERDRAGON") iNumItems = 2;
    if (sTag == "ANCIENTGREENDRAGON") iNumItems = 2;
    if (sTag == "ANCIENTREDDRAGON") iNumItems = 2;
    if (sTag == "ANCIENTSILVERDRAGON") iNumItems = 2;
    if (sTag == "ANCIENTWHITEDRAGON") iNumItems = 2;
    if (sTag == "ANIMALMASTER") iNumItems = 4;
    if (sTag == "ARENACHAMPION") iNumItems = 4;
    if (sTag == "BABYREDDRAGON") iNumItems = 1;
    if (sTag == "BANDITCHIEF") iNumItems = 4;
    if (sTag == "BALKER") iNumItems = 1;
    if (sTag == "BALORLORD") iNumItems = 2;
    if (sTag == "BANDIT") iNumItems = 4;
    if (sTag == "BANDITARCHER") iNumItems = 4;
    if (sTag == "BANDITMAGE") iNumItems = 4;
    if (sTag == "BANDITROGUE") iNumItems = 4;
    if (sTag == "BARROCK") iNumItems = 4;
    if (sTag == "BIKINIMONK") iNumItems = 4;
    if (sTag == "BLACKDRAGONGAURDIAN") iNumItems = 2;
    if (sTag == "BLUEDWARF") iNumItems = 2;
    if (sTag == "BRIGGS") iNumItems = 4;
    if (sTag == "BUDOC") iNumItems = 2;
    if (sTag == "CAINWARRIOR") iNumItems = 4;
    if (sTag == "COPPERDRAGONGAURDIAN") iNumItems = 2;
    if (sTag == "CULTDICIPLE") iNumItems = 1;
    if (sTag == "CULTDICIPLESCOUT") iNumItems = 4;
    if (sTag == "CULTLEADER") iNumItems = 4;
    if (sTag == "CULTOFMINIMAGE") iNumItems = 2;
    if (sTag == "CULTOFMINIWARRIOR") iNumItems = 2;
    if (sTag == "CULTWARRIOR") iNumItems = 1;
    if (sTag == "DRAKALM") iNumItems = 4;
    if (sTag == "DUERGERMAGE") iNumItems = 4;
    if (sTag == "DUERGERROGUE") iNumItems = 4;
    if (sTag == "DUNEPRIEST") iNumItems = 4;
    if (sTag == "DWARFBLADESLINGER") iNumItems = 2;
    if (sTag == "DWARFHIGHWIZARD") iNumItems = 3;
    if (sTag == "DWARFPRIEST") iNumItems = 3;
    if (sTag == "EARTHELEMENTAL") iNumItems = 4;
    if (sTag == "ELRIETHEMIGHTY") iNumItems = 4;
    if (sTag == "EVILFAIRY") iNumItems = 4;
    if (sTag == "FIREDRAGON") iNumItems = 2;
    if (sTag == "FIREELEMENTAL") iNumItems = 4;
    if (sTag == "GHOULLORD") iNumItems = 1;
    if (sTag == "GIANTKEYKEEPER") iNumItems = 4;
    if (sTag == "GIANTMAGE") iNumItems = 1;
    if (sTag == "GLEBUR") iNumItems = 3;
    if (sTag == "GREENDRAGONGAURDIAN") iNumItems = 2;
    if (sTag == "GREENDWARF") iNumItems = 4;
    if (sTag == "HALFBEASTRANGER") iNumItems = 2;
    if (sTag == "HLAFBEASTWARRIOR") iNumItems = 4;
    if (sTag == "HEARTLESS") iNumItems = 2;
    if (sTag == "HOLOGAURD") iNumItems = 2;
    if (sTag == "HOLO") iNumItems = 4;
    if (sTag == "KEEPEROFKEYSEAST") iNumItems = 2;
    if (sTag == "KINGDUERGER") iNumItems = 4;
    if (sTag == "LIGHTINGDRAGON") iNumItems = 1;
    if (sTag == "LIZARDCHIEF") iNumItems = 4;
    if (sTag == "LORDSHACKNUK") iNumItems = 4;
    if (sTag == "MALCOM") iNumItems = 2;
    if (sTag == "MALCOMPROTECTOR") iNumItems = 2;
    if (sTag == "MERCENARY") iNumItems = 2;
    if (sTag == "METALMONK") iNumItems = 6;
    if (sTag == "MINGTAO") iNumItems = 4;
    if (sTag == "MINIMONK") iNumItems = 2;
    if (sTag == "MONKOSAURUS") iNumItems = 2;
    if (sTag == "MONXIE") iNumItems = 1;
    if (sTag == "MRROBATO") iNumItems = 4;
    if (sTag == "MUMMYWARRIOR") iNumItems = 4;
    if (sTag == "NAMELESSCULTPRIEST") iNumItems = 2;
    if (sTag == "NORTHKEEPEROFKEYS") iNumItems = 2;
    if (sTag == "ORC_ARCHER") iNumItems = 4;
    if (sTag == "ORC_CHAMP") iNumItems = 4;
    if (sTag == "ORC_CHIEF") iNumItems = 4;
    if (sTag == "ORC_BOSS") iNumItems = 4;
    if (sTag == "QUEENDUERGER") iNumItems = 4;
    if (sTag == "RAINMAKER") iNumItems = 4;
    if (sTag == "REB") iNumItems = 8;
    if (sTag == "REDDRAGONGAURDIAN") iNumItems = 2;
    if (sTag == "REDDWARF") iNumItems = 2;
    if (sTag == "RETIREDFIGHTER") iNumItems = 3;
    if (sTag == "RONUS") iNumItems = 2;
    if (sTag == "SERF") iNumItems = 3;
    if (sTag == "SHOGUNMUSCLE") iNumItems = 2;
    if (sTag == "SHUGONSHURIKEN") iNumItems = 1;
    if (sTag == "SHOGUNWARRIOR") iNumItems = 2;
    if (sTag == "SOUTHKEEPEROFKEYS") iNumItems = 2;
    if (sTag == "THRULITH") iNumItems = 1;
    if (sTag == "THUNDERLORD") iNumItems = 4;
    if (sTag == "TMGAURD") iNumItems = 2;
    if (sTag == "TMJAILOR") iNumItems = 5;
    if (sTag == "TREVILANCE") iNumItems = 4;
    if (sTag == "VERAN") iNumItems = 4;
    if (sTag == "VOIDMONK") iNumItems = 4;
    if (sTag == "WESTKEEPEROFKEYS") iNumItems = 4;
    if (sTag == "WITCH") iNumItems = 2;
    if (sTag == "ZACHARDTHEGREAT") iNumItems = 4;
    if (sTag == "MASTERCAIN") iNumItems = 7;
    if (sTag == "DUNELORD") iNumItems = 2;
    if (sTag == "QUEENDUERGER") iNumItems = 2;
    if (sTag == "WEREWOLF") iNumItems = 2;
    if (sTag == "DWARFBOSS01") iNumItems = 6;
    if (sTag == "DWARFBOSS02") iNumItems = 6;
    if (sTag == "DEADHEAD") iNumItems = 2;
    if (sTag == "GRANOLA") iNumItems = 2;
    if (sTag == "PAWNTAKER") iNumItems = 4;
    if (sTag == "TMBOSSCHEST_01") iNumItems = 4;
    if (sTag == "TMBOSSCHEST_02") iNumItems = 4;
    if (sTag == "REDPOWDERCHEST") iNumItems = 4;
    if (sTag == "DANCINGSWORDS") iNumItems = 2;
    if (sTag == "FLOATINGSCIMITAR") iNumItems = 2;
    if (sTag == "AIRKEEPER") iNumItems = 2;
    if (sTag == "WATERKEEPER") iNumItems = 2;
    if (sTag == "EARTHKEEPER") iNumItems = 2;
    if (sTag == "LORDOFCHAOS") iNumItems = 2;
    if (sTag == "WARMACHINE") iNumItems = 2;
    if (sTag == "DEAMONSORCERER") iNumItems = 2;
    if (sTag == "FLOATINGBOW") iNumItems = 2;
    if (sTag == "CAINWARRIOR") iNumItems = 2;
    if (sTag == "CAINMAGE") iNumItems = 2;
    if (sTag == "CAINSENIORMAGE") iNumItems = 2;
    if (sTag == "SETH") iNumItems = 6;
    if (sTag == "BARBARIANOUTCAST") iNumItems = 3;
    if (sTag == "ASYRIANHOLYMAN") iNumItems = 2;
    if (sTag == "ASYRIANAXEMAN") iNumItems = 2;
    if (sTag == "ASYRIANSPEARMEN") iNumItems = 2;
    if (sTag == "IRONRANGE") iNumItems = 2;
    if (sTag == "MRINFERNO") iNumItems = 2;
    if (sTag == "MRISSAC") iNumItems = 2;
    if (sTag == "OZKNIGHT") iNumItems = 2;
    if (sTag == "LEGIONARCHER") iNumItems = 2;
    if (sTag == "LEGIONASSASSIN") iNumItems = 2;
    if (sTag == "IRONMINOTAUR") iNumItems = 2;
    if (sTag == "SHADOWLEGIONRANGER") iNumItems = 2;
    if (sTag == "LEGIONWARRIOR") iNumItems = 2;
    if (sTag == "LUCEPH") iNumItems = 3;
    if (sTag == "LUCEPHCAPTIAN") iNumItems = 2;
    if (sTag == "ASYRIANMASTERCRAFTSMAN") iNumItems = 3;
    if (sTag == "OZKING") iNumItems = 2;
    if (sTag == "MASTERASSASSIN") iNumItems = 3;
    if (sTag == "ASYRIANTREASUREGAURD") iNumItems = 2;
    if (sTag == "GRANOLADRUID") iNumItems = 3;
    if (sTag == "ANGUIS") iNumItems = 3;
    if (sTag == "ELRIEOFTHEMYSTIC") iNumItems = 3;
    if (sTag == "RAIDERLEADER") iNumItems = 3;
    if (sTag == "ZACHASAURUS") iNumItems = 4;

    return iNumItems;
}

//:://////////////////////////////////////////////
//::        Function - GetUniqueItemFromList
//:://////////////////////////////////////////////
/*
                Function Description

This function returns the template of an item to be
generated on the list. The number of items in the switch
statment must match the number of items you specified in
GetTotalAvailableItems or it could misfire.


*** MAKE SURE YOU USE THE BLUEPRINT RESREF NOT THE TAG ***

*/

string GetUniqueItemFromList (object oCaller,int iNumber)
{
    string sTag = GetTag (oCaller);
    if (sTag == "AIRELEMENTAL")
        {
        switch (iNumber)
            {
            case 1:return "potionofaid"; break; case 2:return "potioncritical"; break;
            }
        }
    if (sTag == "ANCIENTBLACKDRAGON")
        {
        switch (iNumber)
            {
            case 1:return "blackdragonblood"; break; case 2:return "potioncritical7"; break;
            }
         }

    if (sTag == "ANCIENTBRONZEDRAGON")
        {
        switch (iNumber)
            {
            case 1:return "bronzedragonbloo"; break; case 2:return "potionofaid"; break;
            }
         }


    if (sTag == "ANCIENTCOPPERDRAGON")
        {
        switch (iNumber)
            {
            case 1:return "copperdragonbloo"; break; case 2:return "potionofbarkskin"; break;
            }
         }



    if (sTag == "ANCIENTGREENDRAGON")
        {
        switch (iNumber)
            {
            case 1:return "greendragonblood"; break; case 2:return "potionofbless"; break;
            }
         }


    if (sTag == "ANCIENTREDDRAGON")
        {
        switch (iNumber)
            {
            case 1:return "reddragonblood"; break; case 2:return "healstk10"; break;
            }
         }


    if (sTag == "ANCIENTSILVERDRAGON")
        {
        switch (iNumber)
            {
            case 1:return "silverdragonbloo"; break; case 2:return "potionofclarity"; break;
            }
         }


    if (sTag == "ANCIENTWHITEDRAGON")
        {
        switch (iNumber)
            {
            case 1:return "whitedragonblood"; break; case 2:return "potionmoderate"; break;
            }
         }


    if (sTag == "ANIMALMASTER")
        {
        switch (iNumber)
            {
            case 1:return "beastlybow"; break; case 2:return "rackshastaff"; break;   case 3:return "racksharobe"; break;
            case 4:return "beltofdeflection"; break;
            }
         }


    if (sTag == "ARENACHAMPION")
        {
        switch (iNumber)
            {
            case 1:return "champaxe2"; break; case 2:return "arenachampaxe"; break;   case 3:return "redarenachamp"; break;
            case 4:return "arenachampion001"; break;
            }
         }


    if (sTag == "BABYREDDRAGON")
        {
        switch (iNumber)
            {
            case 1:return "healstk10"; break;
            }
         }


    if (sTag == "BANDITCHIEF")
        {
        switch (iNumber)
            {
            case 1:return "potionserious"; break;
            }
         }


    if (sTag == "BALKER")
        {
        switch (iNumber)
            {
            case 1:return "battlemanclaok"; break;
            }
         }


    if (sTag == "BALORLORD")
        {
        switch (iNumber)
            {
            case 1:return "steelamulet"; break; case 2:return "gold500"; break;
            }
         }


    if (sTag == "BANDIT")
        {
        switch (iNumber)
            {
            case 1:return "potionlight"; break;
            }
         }



    if (sTag == "BANDITARCHER")
        {
        switch (iNumber)
            {
            case 1:return "potionlight"; break;
            }
         }


    if (sTag == "BANDITMAGE")
        {
        switch (iNumber)
            {
            case 1:return "gold100"; break;
            }
         }



    if (sTag == "BANDITROGUE")
        {
        switch (iNumber)
            {
            case 1:return "potionofbless"; break;
            }
         }


    if (sTag == "BARROCK")
        {
        switch (iNumber)
            {
            case 1:return "shieldofdeflecti"; break; case 2:return "shadowhelmit"; break;   case 3:return "gold100"; break;
            case 4:return "goldenhelmet3"; break;
            }
         }


    if (sTag == "BIKINIMONK")
        {
        switch (iNumber)
            {

            case 1:return "naturesarmor"; break; case 2:return "amuletofwind"; break;   case 3:return "potionofaid"; break;
            case 4:return "gold500"; break;
            }
         }



    if (sTag == "BLACKDRAGONGAURDIAN")
        {
        switch (iNumber)
            {
            case 1:return "blackdragonblood"; break; case 2:return "gold500"; break;
            }
         }



    if (sTag == "BLUEDWARF")
        {
        switch (iNumber)
            {
            case 1:return "cust_dw_hammer"; break; case 2:return "cust_bl_dw_armor"; break;
            }
         }



    if (sTag == "BRIGGS")
        {
        switch (iNumber)
            {
            case 1:return "armorofthraag"; break; case 2:return "greataxeofthr002"; break;   case 3:return "improvedlighting"; break;
            case 4:return "gold500"; break;
            }
         }



    if (sTag == "BUDOC")
        {
        switch (iNumber)
            {
            case 1:return "budocrobe"; break; case 2:return "staffofknowledge"; break;
            }
         }


          if (sTag == "CAINWARRIOR")
        {
        switch (iNumber)
            {
            case 1:return "gold500"; break; case 2:return "gold500"; break;   case 3:return "gold500"; break;
            case 4:return "gold500"; break;
            }
         }

          if (sTag == "COPPERDRAGONGAURDIAN")
        {
        switch (iNumber)
            {
            case 1:return "gold500"; break; case 2:return "copperdragonbloo"; break;
            }
         }


           if (sTag == "CULTDICIPLE")
        {
        switch (iNumber)
            {
            case 1:return "greatoakarmor"; break;
            }
         }


          if (sTag == "CULTDICIPLESCOUT")
        {
        switch (iNumber)
            {
            case 1:return "gold500"; break; case 2:return "gold500"; break;   case 3:return "gold500"; break;
            case 4:return "gold500"; break;
            }
         }


             if (sTag == "CULTLEADER")
        {
        switch (iNumber)
            {
            case 1:return "satansatin"; break; case 2:return "cloakofdarkness"; break;   case 3:return "gold1000"; break;
            case 4:return "helmofbrilliance"; break;
            }
         }

            if (sTag == "CULTOFMINIMAGE")
        {
        switch (iNumber)
            {
            case 1:return "cultofminirobe"; break; case 2:return "gold5000"; break;
            }
         }


            if (sTag == "CULTOFMINIWARRIOR")
        {
        switch (iNumber)
            {
            case 1:return "cultofminirobe"; break; case 2:return "gold5000"; break;
            }
         }


            if (sTag == "CULTWARRIOR")
        {
        switch (iNumber)
            {
            case 1:return "cultwarriorarmor"; break;
            }
         }


             if (sTag == "DRAKALM")
        {
        switch (iNumber)
            {
            case 1:return "silverarmor"; break; case 2:return "silvershield"; break;   case 3:return "improvedacid001"; break;
            case 4:return "potionofbless"; break;
            }
         }


              if (sTag == "DUERGERMAGE")
        {
        switch (iNumber)
            {
            case 1:return "gold500"; break; case 2:return "gold500"; break;
            }
         }


               if (sTag == "DUERGERROGUE")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


              if (sTag == "DUNEPRIEST")
        {
        switch (iNumber)
            {
            case 1:return "dwarvenhelmet"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "dwarvenclericarm"; break;
            }
         }


              if (sTag == "DWARFBLADESLINGER")
        {
        switch (iNumber)
            {
            case 1:return "improvedsonic"; break; case 2:return "gold200"; break;
            }
         }


                if (sTag == "DWARFHIGHWIZARD")
        {
        switch (iNumber)
            {
            case 1:return "dwarfhighwizardr"; break; case 2:return "staffofpain"; break;   case 3:return "gold200"; break;
            }
         }


                if (sTag == "DWARFPRIEST")
        {
        switch (iNumber)
            {
            case 1:return "dwarvenclericarm"; break; case 2:return "sunlightsling"; break;   case 3:return "gold200"; break;
            }
         }


               if (sTag == "EARTHELEMENTAL")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


               if (sTag == "ELRIETHEMIGHTY")
        {
        switch (iNumber)
            {
            case 1:return "gold5000"; break; case 2:return "goldenhelmet3"; break;   case 3:return "crownofbrotherho"; break;
            case 4:return "icescythe"; break;
            }
         }


                if (sTag == "EVILFAIRY")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


                if (sTag == "FIREDRAGON")
        {
        switch (iNumber)
            {
            case 1:return "reddragonblood"; break; case 2:return "fireshield"; break;
            }
         }


                 if (sTag == "FIREELEMENTAL")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


                 if (sTag == "GHOULLORD")
        {
        switch (iNumber)
            {
            case 1:return "beltofswordplay"; break;
            }
         }


                 if (sTag == "GIANTKEYKEEPER")
        {
        switch (iNumber)
            {
            case 1:return "gold100"; break; case 2:return "gold100"; break;   case 3:return "gold100"; break;
            case 4:return "gold100"; break;
            }
         }


                 if (sTag == "GIANTMAGE")
        {
        switch (iNumber)
            {
            case 1:return "gold100"; break;
            }
         }


                 if (sTag == "GLEBUR")
        {
        switch (iNumber)
            {
            case 1:return "devilstail"; break; case 2:return "rubystarshield"; break;   case 3:return "dwarvenroguearmo"; break;
            }
         }


                 if (sTag == "GREENDRAGONGAURDIAN")
        {
        switch (iNumber)
            {
            case 1:return "greendragonblood"; break; case 2:return "gold500"; break;
            }
         }



                 if (sTag == "GREENDWARF")
        {
        switch (iNumber)
            {
            case 1:return "cust_dw_great_sw"; break; case 2:return "cust_dw_armor"; break;
            }
         }


                if (sTag == "HALFBEASTRANGER")
        {
        switch (iNumber)
            {
            case 1:return "pixieboots"; break; case 2:return "rangerbracers"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }



                 if (sTag == "HLAFBEASTWARRIOR")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


                 if (sTag == "HEARTLESS")
        {
        switch (iNumber)
            {
            case 1:return "heartlessrobe"; break; case 2:return "gold200"; break;
            }
         }


                  if (sTag == "HOLOGAURD")
        {
        switch (iNumber)
            {
            case 1:return "goldenarmor3"; break; case 2:return "gold200"; break;
            }
         }


                  if (sTag == "HOLO")
        {
        switch (iNumber)
            {
            case 1:return "holoarmor"; break; case 2:return "holohelmet"; break;   case 3:return "holomace"; break;
            case 4:return "prayerbelt"; break;
            }
         }



                  if (sTag == "KEEPEROFKEYSEAST")
        {
        switch (iNumber)
            {
            case 1:return "mageprotector01"; break; case 2:return "gold200"; break;
            }
         }


                 if (sTag == "KINGDUERGER")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }

                 if (sTag == "LIGHTINGDRAGON")
        {
        switch (iNumber)
            {
            case 1:return "improvedlighting"; break;
            }
         }


          if (sTag == "LIZARDCHIEF")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }

             if (sTag == "LORDSHACKNUK")
        {
        switch (iNumber)
            {
            case 1:return "dracoblake"; break; case 2:return "dracoblake001"; break;   case 3:return "dracoblake003"; break;
            case 4:return "dracoblake002"; break;
            }
         }


             if (sTag == "MALCOM")
        {
        switch (iNumber)
            {
            case 1:return "malcomgreatsword"; break; case 2:return "silverlongsword"; break;
            }
         }


               if (sTag == "MALCOMPROTECTOR")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


               if (sTag == "MERCENARY")
        {
        switch (iNumber)
            {
            case 1:return "mercsword"; break; case 2:return "mercshield"; break;
            }
         }


                if (sTag == "METALMONK")
        {
        switch (iNumber)
            {
            case 1:return "metalmonkrobes"; break;
            case 2:return "metmnkgaunts"; break;
            case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            case 5:return "gold200"; break;
            case 6:return "gold200"; break;
            }
         }


                if (sTag == "MINGTAO")
        {
        switch (iNumber)
            {
            case 1:return "mingtaorobe"; break; case 2:return "misticcloak"; break;   case 3:return "gold5000"; break;
            case 4:return "mingtaostaff"; break;
            }
         }


                 if (sTag == "MINIMONK")
        {
        switch (iNumber)
            {
            case 1:return "minimonkrobe"; break; case 2:return "minimonkgauntlet"; break;
            }
         }


                 if (sTag == "MONKOSAURUS")
        {
        switch (iNumber)
            {
            case 1:return "helmetofmonko"; break; case 2:return "bladeofthelizard"; break;
            }
         }


                 if (sTag == "MONXIE")
        {
        switch (iNumber)
            {
            case 1:return "monxiegauntlets"; break;
            }
         }



                 if (sTag == "MRROBATO")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


                 if (sTag == "MUMMYWARRIOR")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }



                 if (sTag == "NAMELESSCULTPRIEST")
        {
        switch (iNumber)
            {
            case 1:return "evilclerichelm"; break; case 2:return "potionofaid"; break;
            }
         }


                 if (sTag == "NORTHKEEPEROFKEYS")
        {
        switch (iNumber)
            {
            case 1:return "enchantedrobes"; break; case 2:return "staffofpain"; break;
            }
         }


                 if (sTag == "ORC_ARCHER")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


                  if (sTag == "ORC_CHAMP")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


                  if (sTag == "ORC_CHIEF")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "godswill"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


                  if (sTag == "ORC_BOSS")
        {
        switch (iNumber)
            {
            case 1:return "steelamulet"; break; case 2:return "orcjustice"; break;
            }
         }


                  if (sTag == "QUEENDUERGER")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


                  if (sTag == "RAINMAKER")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


                   if (sTag == "REB")
        {
        switch (iNumber)
            {
            case 1:return "cloth032"; break; case 2:return "crownofbuddha"; break;   case 3:return "cloakofbuddha"; break;
            case 4:return "buddhaboots"; break; case 5:return "ringofbuddha"; break; case 6: return "amuletofbuddha"; break;
            case 7:return "item016"; break; case 8:return "glovesofbuddha"; break;
            }
         }


                  if (sTag == "REDDRAGONGAURDIAN")
        {
        switch (iNumber)
            {
            case 1:return "gold500"; break; case 2:return "reddragonblood"; break;
            }
         }


                  if (sTag == "REDDWARF")
        {
        switch (iNumber)
            {
            case 1:return "cust_reddwarf"; break; case 2:return "cust_dwarfaxe"; break;
            }
         }


                  if (sTag == "RETIREDFIGHTER")
        {
        switch (iNumber)
            {
            case 1:return "retiredfighterar"; break; case 2:return "oldshield"; break;   case 3:return "oldsword"; break;
            }
         }


                   if (sTag == "RONUS")
        {
        switch (iNumber)
            {
            case 1:return "bladeslingerarmor"; break; case 2:return "bladeslinger"; break;
            }
         }


                   if (sTag == "SERF")
        {
        switch (iNumber)
            {
            case 1:return "armorofserf"; break; case 2:return "beltofcenobit"; break;   case 3:return "cloakoflife"; break;
            }
         }


                   if (sTag == "SHOGUNMUSCLE")
        {
        switch (iNumber)
            {
            case 1:return "shogungauntlets"; break; case 2:return "shogunrobes"; break;
            }
         }


                    if (sTag == "SHUGONSHURIKEN")
        {
        switch (iNumber)
            {
            case 1:return "starsofholyness"; break;
            }
         }


                   if (sTag == "SHOGUNWARRIOR")
        {
        switch (iNumber)
            {
            case 1:return "swrobes"; break; case 2:return "kamachameleon"; break;
            }
         }


                   if (sTag == "SOUTHKEEPEROFKEYS")
        {
        switch (iNumber)
            {
            case 1:return "keepersaxe"; break; case 2:return "barbarmor"; break;
            }
         }


                   if (sTag == "THRULITH")
        {
        switch (iNumber)
            {
            case 1:return "armorofbark"; break;
            }
         }


                  if (sTag == "THUNDERLORD")
        {
        switch (iNumber)
            {
            case 1:return "thunderlord001"; break; case 2:return "tmkingshield"; break;   case 3:return "titaniumshield"; break;
            case 4:return "tmkingarmor"; break;
            }
         }

              if (sTag == "TMGAURD")
        {
        switch (iNumber)
            {
            case 1:return "tmgaurdhelmit"; break; case 2:return "tmgaurdarmor"; break;
            }
         }


           if (sTag == "TMJAILOR")
        {
        switch (iNumber)
            {
            case 1:return "tmjailor"; break; case 2:return "tmjailor02"; break;   case 3:return "jailorsword"; break;
            case 4:return "tmjailorcloak"; break; case 5:return "tmjailorshield"; break;

            }
         }


             if (sTag == "TREVILANCE")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


               if (sTag == "VERAN")
        {
        switch (iNumber)
            {
            case 1:return "gold200"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


               if (sTag == "VOIDMONK")
        {
        switch (iNumber)
            {
            case 1:return "voidrobes"; break; case 2:return "gold200"; break; case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


               if (sTag == "WESTKEEPEROFKEYS")
        {
        switch (iNumber)
            {
            case 1:return "robesofshadows"; break; case 2:return "gold200"; break;   case 3:return "gold200"; break;
            case 4:return "gold200"; break;
            }
         }


               if (sTag == "WITCH")
        {
        switch (iNumber)
            {
            case 1:return "witchrobe"; break; case 2:return "potioncritical"; break;
            }
         }


                if (sTag == "ZACHARDTHEGREAT")
        {
        switch (iNumber)
            {
            case 1:return "arrowofmorkains"; break; case 2:return "armorofshinin"; break;   case 3:return "silverknightshie"; break;
            case 4:return "firehalberd"; break;
            }
         }


                if (sTag == "MASTERCAIN")
        {
        switch (iNumber)
            {
            case 1:return "cainarmor"; break; case 2:return "cainhelmet"; break;   case 3:return "cainshield"; break;
            case 4:return "cainboots"; break; case 5:return "cainbastardsword"; break; case 6:return "arrowoftheelmen";
            break; case 7:return "bootsofwind";
            break;
            }
         }

                  if (sTag == "DUNELORD")
        {
        switch (iNumber)
            {
            case 1:return "amuletofdesertwi"; break; case 2:return "dunelordeye"; break;
            }
         }


                     if (sTag == "WEREWOLF")
        {
        switch (iNumber)
            {
            case 1:return "gold100"; break; case 2:return "potionbulls"; break;
            }
         }


                    if (sTag == "QUEENDUERGER")
        {
        switch (iNumber)
            {
            case 1:return "royalstaff"; break; case 2:return "rubystarshield"; break;
            }
         }


                if (sTag == "DWARFBOSS01")
        {
        switch (iNumber)
            {
            case 1:return "archerybracers"; break; case 2:return "barbarianbelt"; break;   case 3:return "staffofchoice"; break;
            case 4:return "trollboots"; break; case 5:return "pixieboots"; break; case 6:return "gold5000";
            break;
            }
         }


                if (sTag == "DWARFBOSS02")
        {
        switch (iNumber)
            {
            case 1:return "improvedlighting"; break; case 2:return "leathercloak"; break;   case 3:return "gold5000"; break;
            case 4:return "trollboots"; break; case 5:return "arrowofdeath"; break; case 6:return "heal_stk_10";
            break;
            }
         }


               if (sTag == "DEADHEAD")
        {
        switch (iNumber)
            {
            case 1:return "antiquespear"; break; case 2:return "potionofbarkskin"; break;
            }
         }


               if (sTag == "GRANOLA")
        {
        switch (iNumber)
            {
            case 1:return "birkenstocks"; break; case 2:return "granolaarmor"; break;
            }

         }


         if (sTag == "PAWNTAKER")
        {
        switch (iNumber)
            {
            case 1:return "garthbelt"; break; case 2:return "pawnboots"; break;   case 3:return "pawnssitar"; break;
            case 4:return "elvisarmor"; break;
            }
         }


          if (sTag == "LIZARDBOSS")
        {
        switch (iNumber)
            {
            case 1:return "lizardrapier"; break; case 2:return "gold1000"; break;
            }
         }

         if (sTag == "TMBOSSCHEST_01")
        {
        switch (iNumber)
            {
            case 1:return "silverknightarmor"; break; case 2:return "silverarmor"; break;   case 3:return "gold5000"; break;
            case 4:return "beltofdeflection"; break;
            }
         }

         if (sTag == "TMBOSSCHEST_02")
        {
        switch (iNumber)
            {
            case 1:return "helmofbrilliance"; break; case 2:return "fireshield"; break;   case 3:return "gold5000"; break;
            case 4:return "beltofhammering"; break;
            }
         }


         if (sTag == "REDPOWDERCHEST")
        {
        switch (iNumber)
            {
            case 1:return "redmagicalpowder"; break; case 2:return "potionofaid"; break;   case 3:return "potionofbless"; break;
            case 4:return "healstk10"; break;
            }
         }


               if (sTag == "DANCINGSWORDS")
        {
        switch (iNumber)
            {
            case 1:return "dancingsword"; break; case 2:return "potionofaid"; break;
            }

         }



                if (sTag == "AIRKEEPER")
        {
        switch (iNumber)
            {
            case 1:return "potioncritical"; break; case 2:return "gold1000"; break;
            }

         }



               if (sTag == "WATERKEEPER")
        {
        switch (iNumber)
            {
            case 1:return "birkenstocks"; break; case 2:return "granolaarmor"; break;
            }

         }



               if (sTag == "EARTHKEEPER")
        {
        switch (iNumber)
            {
            case 1:return "silvershield"; break; case 2:return "potioncritical"; break;
            }

         }


               if (sTag == "LORDOFCHAOS")
        {
        switch (iNumber)
            {
            case 1:return "flamesofchaos"; break; case 2:return "gold5000"; break;
            }

         }


               if (sTag == "WARMACHINE")
        {
        switch (iNumber)
            {
            case 1:return "warmachinesword"; break; case 2:return "gold100"; break;
            }

         }



                if (sTag == "DEAMONSORCERER")
        {
        switch (iNumber)
            {
            case 1:return "deamonrobe"; break; case 2:return "gold5000"; break;
            }

         }



                if (sTag == "FLOATINGBOW")
        {
        switch (iNumber)
            {
            case 1:return "floatingbow"; break; case 2:return "gold500"; break;
            }

         }



                if (sTag == "CAINWARRIOR")
        {
        switch (iNumber)
            {
            case 1:return "devilswill"; break; case 2:return "potionofaid"; break;
            }

         }



               if (sTag == "CAINMAGE")
        {
        switch (iNumber)
            {
            case 1:return "cainmagerobe"; break; case 2:return "cainmagestaff"; break;
            }

         }


               if (sTag == "CAINSENIORMAGE")
        {
        switch (iNumber)
            {
            case 1:return "gold5000"; break; case 2:return "gold5000"; break;
            }

         }


                if (sTag == "SETH")
        {
        switch (iNumber)
            {
            case 1:return "sethhelmet"; break; case 2:return "setharmor"; break;   case 3:return "sethbow"; break;
            case 4:return "sethrobe"; break; case 5:return "holystrike"; break; case 6:return "sethscythe001";
            break;
            }
         }



               if (sTag == "WESTKEEPEROFKEYS")
        {
        switch (iNumber)
            {
            case 1:return "outcastarmor"; break; case 2:return "outcastshield"; break;   case 3:return "outcastaxe"; break;
            }
         }


                if (sTag == "ASYRIANHOLYMAN")
        {
        switch (iNumber)
            {
            case 1:return "asyrianmorningst"; break; case 2:return "asyrianholymanhe"; break;
            }

         }



               if (sTag == "ASYRIANAXEMAN")
        {
        switch (iNumber)
            {
            case 1:return "asyrianwarriorhe"; break; case 2:return "gold500"; break;
            }

         }



               if (sTag == "ASYRIANSPEARMEN")
        {
        switch (iNumber)
            {
            case 1:return "asyrianspear"; break; case 2:return "gold500"; break;
            }

         }


                if (sTag == "IRONRANGE")
        {
        switch (iNumber)
            {
            case 1:return "ironclawthrowing"; break; case 2:return "gold500"; break;
            }

         }



               if (sTag == "MRINFERNO")
        {
        switch (iNumber)
            {
            case 1:return "infernostaff"; break; case 2:return "gold500"; break;
            }

         }

                 if (sTag == "MRISSAC")
        {
        switch (iNumber)
            {
            case 1:return "issacstaff"; break; case 2:return "issacrobe"; break;
            }
         }


                if (sTag == "OZKNIGHT")
        {
        switch (iNumber)
            {
            case 1:return "gnomedefense"; break; case 2:return "gnomemight"; break;
            }

         }


                if (sTag == "LEGIONARCHER")
        {
        switch (iNumber)
            {
            case 1:return "assassinbow"; break; case 2:return "assassinacid"; break;
            }

         }

                if (sTag == "IRONMINOTAUR")
        {
        switch (iNumber)
            {
            case 1:return "ironminotaurswor"; break; case 2:return "gold500"; break;
            }

         }



               if (sTag == "SHADOWLEGIONRANGER")
        {
        switch (iNumber)
            {
            case 1:return "legionbow"; break; case 2:return "gold500"; break;
            }

         }


                if (sTag == "LEGIONWARRIOR")
        {
        switch (iNumber)
            {
            case 1:return "legionscimitar"; break; case 2:return "gold500"; break;
            }

         }

                if (sTag == "LUCEPH")
        {
        switch (iNumber)
            {
            case 1:return "ironclawaxe"; break; case 2:return "oldbastardsword"; break; case 3:return "oldpiercedshield"; break;
            }

         }


                if (sTag == "LUCEPHCAPTIAN")
        {
        switch (iNumber)
            {
            case 1:return "ironclawarmor2"; break; case 2:return "lucephcptmace"; break;
            }

         }

                if (sTag == "ASYRIANMASTERCRAFTSMAN")
        {
        switch (iNumber)
            {
            case 1:return "rustedarmor"; break; case 2:return "rustedhelmet"; break; case 3:return "asyrianmorningst"; break;
            }

         }



               if (sTag == "OZKING")
        {
        switch (iNumber)
            {
            case 1:return "oldweatheredrobe"; break; case 2:return "ringoflegends"; break; case 3:return "oznoblestaff"; break;
            }

         }


                if (sTag == "MASTERASSASSIN")
        {
        switch (iNumber)
            {
            case 1:return "legendshortsword"; break; case 2:return "bloodstainedarmo"; break; case 3:return "bardbracers"; break;
            }

         }

                if (sTag == "ASYRIANTREASUREGAURD")
        {
        switch (iNumber)
            {
            case 1:return "asyrianwarriorar"; break; case 2:return "asyriandoubleaxe"; break;
            }

         }

                  if (sTag == "GRANOLADRUID")
        {
        switch (iNumber)
            {
            case 1:return "granolaarmor"; break; case 2:return "gold500"; break; case 3:return "granolastick"; break;
            }

         }


                   if (sTag == "ANGUIS")
        {
        switch (iNumber)
            {
            case 1:return "anguissword"; break; case 2:return "mirrorarmor"; break; case 3:return "gold500"; break;
            }

         }

                  if (sTag == "ELRIEOFTHEMYSTIC")
        {
        switch (iNumber)
            {
            case 1:return "mysticamulet"; break; case 2:return "arcanebattlerobe"; break; case 3:return "mysticlongsword"; break;
            }

         }

                   if (sTag == "RAIDERLEADER")
        {
        switch (iNumber)
            {
            case 1:return "banditring"; break; case 2:return "gold500"; break; case 3:return "mirrorarmor"; break;
            }

         }

                   if (sTag == "ZACHASAURS")
        {
        switch (iNumber)
            {
            case 1:return "arcanebattlerobe"; break; case 2:return "ironboots"; break; case 3:return "beltofzachasauru"; break;
            case 4:return "amuletofzach"; break;
            }

         }
    return "ERROR - NO TAG MATCH";
}
