//::///////////////////////////////////////////////
//:: Name: Custom item activation
//:: FileName: trinity_activate
//:://////////////////////////////////////////////
/*

This script goes in the OnItemActivation event of your Module
Properties.

*/
//:://////////////////////////////////////////////
//:: Last Modified By: Charles
//:: Last Modified On: August 2003
//:://////////////////////////////////////////////

#include "cs_misc_function"

void main()
{
    // WriteTimestampedLogEntry("Entering Module onActivateItem: trinity_activate");

    //
    // This script will run on ANY activated object.  The name of the object is the name of the
    // script that will be executed.
    //
    // Example:
    //
    // The 'HOMESTONE' Tag will result in a call of the 'homestone' script.  It is not case sensitive...
    //
    // Current Tags available:
    //
    // Homestone
    // Badgerhealm
    // KeyOfCheating
    // Hornoftheguards
    // Globeoftherelease
    // Symbolofmight
    // xx_tmport
    // xx_dwarfport
    // xx_manyport
    // xx_cavesport
    // xx_snowport
    // xx_ironport
    // legendpallyaa


    cs_DEBUG_ON();
    cs_DEBUG_SPEAK("Executing Script: " + GetTag(GetItemActivated()));
    ExecuteScript(GetTag(GetItemActivated()), OBJECT_SELF);
    cs_DEBUG_OFF();

  //Shifter
  object oItem = GetItemActivated();
  object oPC = GetItemActivator();
  string sItem = GetTag(oItem);

  if (sItem == "ShifterControl")
  {
    SetLocalString(GetModule(), "TheShifter", sItem);
    AssignCommand(oPC, ActionStartConversation(oPC, "shifter", TRUE) );
  }

  if (sItem == "BLADEOFMAGICAL" ||
      sItem == "BLADEOFDIVINE" ||
      sItem == "DARKNESSESBANE" ||
      sItem == "BLADEOFTHELOWERREALMS")
  {
    AssignCommand(oPC, ActionStartConversation(oPC, "shifterenergy", TRUE) );
  }

  if (sItem == "AWRINGOFVERAPLAYER")
    ExecuteScript("aw_staffofvera", oPC);
  if (sItem == "AWDRUIDBUFF")
    AssignCommand(oPC, ActionStartConversation(oPC, "awdruidbuff", TRUE) );
}
